/* /////////////////////////////////////////////////////////////////////////////
 * File:        errorinfo_functions_c_test.c
 *
 * Purpose:     Implementation file for the errorinfo_functions_c_test project.
 *
 * Created:     26th April 2005
 * Updated:     26th April 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright 1999-2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2005
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>

#include <comstl.h>
#include <comstl/errorinfo_functions.h>

/* Standard C Header Files */
#include <stdio.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

void dump_errorinfo(void);

/* ////////////////////////////////////////////////////////////////////////// */

int main(int argc, char *argv[])
{
#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	puts("errorinfo_functions_c_test: " __STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

#if 0
	Sleep(100000);
#endif /* 0 */

	((void)argc);
	((void)argv);
	/* . */

	{
		comstl__set_error_info_description_w(L"Something's wrong");
		dump_errorinfo();

		comstl__set_error_info_description_and_source_w(L"Something's wrong", L"errorinfo_functions_c_test");
		dump_errorinfo();

		comstl__set_error_info_w(L"Something's wrong", L"errorinfo_functions_c_test", &IID_IUnknown, L"eek.hlp", 127);
		dump_errorinfo();
	}

	{
		comstl__set_error_info_description_a("Something's wrong");
		dump_errorinfo();

		comstl__set_error_info_description_and_source_a("Something's wrong", "errorinfo_functions_c_test");
		dump_errorinfo();

		comstl__set_error_info_a("Something's wrong", "errorinfo_functions_c_test", &IID_IUnknown, "eek.hlp", 127);
		dump_errorinfo();
	}

    return 0;
}


/* ////////////////////////////////////////////////////////////////////////// */

#define	to_s(s)		((NULL == (s)) ? L"" : (s))

void dump_errorinfo(void)
{
	IErrorInfo	*pEI;
	HRESULT		hr	=	GetErrorInfo(0, &pEI);

	if(SUCCEEDED(hr))
	{
		BSTR	bstrDescription;
		BSTR	bstrSource;
		GUID	guid;
		BSTR	bstrHelpFile;
		DWORD	dwHelpContext;

		if(FAILED(COMSTL_ITF_CALL(pEI)->GetDescription(COMSTL_ITF_THIS(pEI) &bstrDescription)))
		{
			bstrDescription = NULL;
		}
		if(FAILED(COMSTL_ITF_CALL(pEI)->GetSource(COMSTL_ITF_THIS(pEI) &bstrSource)))
		{
			bstrSource = NULL;
		}
		if(FAILED(COMSTL_ITF_CALL(pEI)->GetGUID(COMSTL_ITF_THIS(pEI) &guid)))
		{
			guid = GUID_NULL;
		}
		if(FAILED(COMSTL_ITF_CALL(pEI)->GetHelpFile(COMSTL_ITF_THIS(pEI) &bstrHelpFile)))
		{
			bstrHelpFile = NULL;
		}
		if(FAILED(COMSTL_ITF_CALL(pEI)->GetHelpContext(COMSTL_ITF_THIS(pEI) &dwHelpContext)))
		{
			dwHelpContext = 0;
		}

		wprintf(	L"\n"
					L"  description:   %s\n"
					L"  source:        %s\n"
					L"  GUID:          { %08x, %04x, %04x, %02x, %02x, %02x, %02x, %02x, %02x, %02x, %02x } \n"
					L"  help:          %s(%u)\n"
				,	to_s(bstrDescription)
				,	to_s(bstrSource)
				,	guid.Data1, guid.Data2, guid.Data3, guid.Data4[0], guid.Data4[1], guid.Data4[2], guid.Data4[3], guid.Data4[4], guid.Data4[5], guid.Data4[6], guid.Data4[7] 
				,	to_s(bstrHelpFile), dwHelpContext);

		SysFreeString(bstrDescription);
		SysFreeString(bstrSource);
		SysFreeString(bstrHelpFile);
	}
}

/* ////////////////////////////////////////////////////////////////////////// */
