/* /////////////////////////////////////////////////////////////////////////////
 * File:        environment_block_test.cpp
 *
 * Purpose:     Implementation file for the environment_block_test project.
 *
 * Created:     1st July 2004
 * Updated:     11th September 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#include <stlsoft.h>
#include <stlsoft_environment_block.h>

stlsoft_ns_using(environment_block_a)

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

#if (   defined(WIN32) || \
        defined(_WIN32)) && \
    !defined(_INC_WINDOWS)
extern "C" void __stdcall Sleep(unsigned long);
#endif /* WIN32 */

/* ////////////////////////////////////////////////////////////////////////// */

int main(int argc, char *argv[])
{
#if 0
	::Sleep(100000);
#endif /* 0 */

#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	puts("environment_block_test: " __STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

    int                 iRet    =   0;
    int                 i;
	environment_block_a	eb;

	for(i = 1; i < argc; ++i)
	{
		char const	*arg	=	argv[i];
		char const	*eq		=	strchr(arg, '=');

		if(NULL == eq)
		{
			eb.push_back(arg);
		}
		else
		{
			eb.push_back(arg, eq - arg, eq + 1, strlen(eq + 1));
		}

		if(arg[0] == '-')
		{
			if(arg[1] == '-')
			{
				/* -- arguments */
			}
			else
			{
				/* - arguments */
			}
		}
		else
		{
			/* other arguments */
		}
	}

	/* . */
	printf("Num: %u\n", eb.size());
	char const * const*	base = eb.base();
	for(i = 0; i < eb.size(); ++i)
	{
		printf("  \"%s\"\n", i[eb.base()]);
	}

    return iRet;
}

/* ////////////////////////////////////////////////////////////////////////// */
