/* /////////////////////////////////////////////////////////////////////////////
 * File:        type_traits_test.cpp
 *
 * Purpose:     Implementation file for the type_traits_test project.
 *
 * Created:     18th January 2004
 * Updated:     22nd April 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#define _STLSOFT_NO_NAMESPACE

#include <stlsoft.h>
#include <stlsoft_meta.h>
#include <stlsoft_type_traits.h>

/* ////////////////////////////////////////////////////////////////////////// */

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

	puts("type_traits_test: " __STLSOFT_COMPILER_LABEL_STRING);

	/* . */
	int			i;
	int			ai[2];
	int			*pi;


#define boolstr_(b)		(char const *)((b) ? "true" : "false")

#define boolstr(x, q)	boolstr_(stlsoft_ns_qual(base_type_traits)<x>::q)

#define describe(x)	printf("%s:\n\tptr: %s\n\tref: %s\n\tarray: %s\n\tconst: %s\n\tvolatile: %s\n", #x, boolstr(x, is_pointer), boolstr(x, is_reference), boolstr_(is_array_type<x>::value), boolstr(x, is_const), boolstr(x, is_volatile))

	typedef int int_array_t[2];

	describe(int);
	describe(int_array_t);
	describe(int*);

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
