
// This will cause various compile-time messages to be emitted. When you get
// sick of them just comment out or remove this #define
#define	_STLSOFT_COMPILE_VERBOSE

#include <stlsoft.h>
#include <stlsoft/printf_traits.hpp>

#include <unixstl.h>

#include <unixstl/performance_counter.hpp>

unixstl_ns_using(performance_counter)

#include <stdio.h>
#include <stdlib.h>

#if defined(STLSOFT_COMPILER_IS_DMC) || \
    defined(STLSOFT_COMPILER_IS_MSVC) || \
    (   defined(STLSOFT_COMPILER_IS_INTEL) && \
        defined(WIN32))
# define	sleep		_sleep
#endif /* compiler */

/* ////////////////////////////////////////////////////////////////////////// */

static void print_counter(performance_counter const &counter)
{
	performance_counter::interval_type	period_count	=	counter.get_period_count();
	performance_counter::interval_type	seconds			=	counter.get_seconds();
	performance_counter::interval_type	milliseconds	=	counter.get_milliseconds();
	performance_counter::interval_type	microseconds	=	counter.get_microseconds();

	char	szFmt[101];

	sprintf(&szFmt[0]
		,	"%s %ss %sms %sus\n"
		,	stlsoft_ns_qual(printf_traits)<performance_counter::interval_type>::format_a()
		,	stlsoft_ns_qual(printf_traits)<performance_counter::interval_type>::format_a()
		,	stlsoft_ns_qual(printf_traits)<performance_counter::interval_type>::format_a()
		,	stlsoft_ns_qual(printf_traits)<performance_counter::interval_type>::format_a()
		);

	printf(	szFmt,
			period_count,
			seconds,
			milliseconds,
			microseconds);
}

int main(int /* argc */, char ** /* argv */)
{
	performance_counter	counter;

	{
		counter.start();
		::sleep(100);
		counter.stop();
		print_counter(counter);
	}

	{
		counter.start();
		::sleep(500);
		counter.stop();
		print_counter(counter);
	}

	{
		counter.start();
		::sleep(1000);
		counter.stop();
		print_counter(counter);
	}

	{
		counter.start();
		::sleep(2500);
		counter.stop();
		print_counter(counter);
	}

	{
		counter.start();
		for(volatile int i = 0; i < 0x7ffffff; ++i)
		{}
		counter.stop();
		print_counter(counter);
	}

	{
		counter.start();
		for(volatile int i = 0; i < 0x7fffffff; ++i)
		{}
		counter.stop();
		print_counter(counter);
	}

	return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
