/* /////////////////////////////////////////////////////////////////////////////
 * File:        path_test.cpp
 *
 * Purpose:     Implementation file for the path_test project.
 *
 * Created:     1st March 2005
 * Updated:     14th March 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2005
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>

#include <winstl.h>
#include <winstl_path.h>


/* Standard C Header Files */
#include <stdio.h>
#include <windows.h>

/* Standard C++ Header Files */

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */


/* ////////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	puts("path_test: " __STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

	/* . */
	::winstl::path_a	path1("..");
	::winstl::path_a	path2(".\\..");

	if(!path1.equivalent(path2))
	{
		puts("Oops!");

		printf("path1: %s\n", path1.c_str());
		printf("path2: %s\n", path2.c_str());
	}

	{
#if 0
		::winstl::path_a	path("\\\\glandon\\Exchange\\articles\\..\\articles\\nocrt.pdf");
#else /* ? 0 */
		::winstl::path_a	path("\\\\glandon/Exchange\\articles\\..\\articles\\nocrt.pdf");
#endif /* 0 */

		path.canonicalise();

		printf("path1: %s\n", path.c_str());
	}

    return 0;
}

int main(int argc, char *argv[])
{
	try
	{
		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		fprintf(stderr, "Unhandled error: %s\n", x.what());
	}
	catch(...)
	{
		fprintf(stderr, "Unhandled unknown error\n");
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
